package org.spring.heat.services;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

import javax.servlet.ServletContext;
import javax.servlet.http.HttpSession;

import org.bak.heat.domain.StaffInfo;
import org.hibernate.Query;
import org.hibernate.Session;
import org.hibernate.SessionFactory;
import org.hibernate.Transaction;
import org.hibernate.heat.domain.HeatsysSetting;
import org.hibernate.heat.domain.OperationgroupInfo;
import org.hibernate.heat.domain.StfGrpPjtMapping;
import org.spring.heat.entity.UserInfo;
import org.spring.heat.models.BaseInfo;
import org.spring.heat.models.Global;
import org.spring.heat.models.ListCount;
import org.spring.heat.models.ProjectInfo;
import org.spring.heat.models.Result;
import org.springframework.context.ApplicationContext;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.orm.hibernate3.SessionFactoryUtils;
import org.springframework.stereotype.Service;
import org.springframework.web.context.support.WebApplicationContextUtils;

@Service
public class ProjectAssignService {
	private JdbcTemplate jdbcTemplate;
	public JdbcTemplate getJdbcTemplate() {
		return jdbcTemplate;
	}
	public void setJdbcTemplate(JdbcTemplate jdbcTemplate) {
		this.jdbcTemplate = jdbcTemplate;
	}
	//get permission group 
	public ArrayList<ArrayList<Object>> getRight(){
		ArrayList<ArrayList<Object>> list = new ArrayList<ArrayList<Object>>();
		String sql = "select * from operationgroup_info";
		List rows = this.getJdbcTemplate().queryForList(sql);
		Iterator it = rows.iterator();
		while(it.hasNext()){
			Map map = (Map)it.next();
			ArrayList<Object> temp = new ArrayList<Object>();
			temp.add(map.get("oprgroupid"));
			temp.add(map.get("groupname"));
			list.add(temp);
		}
		return list;
	}
	//get project which this staff belong to
	public ArrayList<ProjectInfo> getProject(Long stfid){
		String sql = null;
		ArrayList<ProjectInfo> list = new ArrayList<ProjectInfo>();
		if(stfid==null)
			sql = "select pjtid,pjtname from project_info";
		else 
			sql = "select pjtid,pjtname from project_info where stfid ="+stfid;
		List rows = this.getJdbcTemplate().queryForList(sql);
		Iterator it = rows.iterator();
		ProjectInfo temp = null;
		while(it.hasNext()){
			Map map = (Map)it.next();
			temp = new ProjectInfo();
			temp.setPjtid(((BigDecimal)map.get("pjtid")).longValue());
			temp.setPjtname((String)map.get("pjtname"));
			list.add(temp);
		}
		return list;
	}
	//get users on query condition or get all users where query is null
	public List getUsers(String query){
		String sql = "select * from users_info where isvalid = 1";
		if(query!=null)
			sql = sql+" and (usrname like '%"+query+"' or usrtype like '%"+query+"')";
		List list = new ArrayList();
		List rows =this.getJdbcTemplate().queryForList(sql);
		Iterator it = rows.iterator();
		while(it.hasNext()){
			Map map = (Map)it.next();
			UserInfo temp = new UserInfo();
// ??? ??? need to motify
			temp.setUsrid((Long)Global.toNullString(map, "usrid", "BigDecimal", "Long"));
			temp.setUsertype((String)Global.toNullString(map, "usertype", "String", "String"));
			temp.setAddress((String)Global.toNullString(map, "address", "String", "String"));
			temp.setUsrname((String)Global.toNullString(map, "usrname", "String", "String"));
			temp.setPhone((String)Global.toNullString(map, "phone", "String", "String"));
			temp.setStartdate((String)Global.toNullString(map, "startdate", "Timestamp", "String"));
			temp.setContractdate((String)Global.toNullString(map, "contractdate", "Timestamp", "String"));
			temp.setContracttype((String)Global.toNullString(map,"contracttype","String","String"));
			temp.setContractver((String)Global.toNullString(map,"contractver","String","String"));
			temp.setContractpic((String)Global.toNullString(map,"contractpic","String","String"));
			temp.setIdpic((String)Global.toNullString(map,"idpic","String","String"));
			temp.setHouseidpic((String)Global.toNullString(map,"houseidpic","String","String"));
			temp.setHousepic((String)Global.toNullString(map,"housepic","String","String"));
			temp.setDesp((String)Global.toNullString(map,"desp","String","String"));
			temp.setArea((Double)Global.toNullString(map, "area", "BigDecimal", "Double"));
			temp.setRealarea((Double)Global.toNullString(map, "realarea", "BigDecimal", "Double"));
			temp.setFeearea((Double)Global.toNullString(map, "feearea", "BigDecimal", "Double"));
			temp.setFeetype((String)Global.toNullString(map, "feetype", "String", "String"));
			temp.setFeerate((Double)Global.toNullString(map, "feerate", "BigDecimal", "Double"));
			temp.setDiscount((Double)Global.toNullString(map, "discount", "BigDecimal", "Double"));
			temp.setReducefee((Double)Global.toNullString(map, "reducefee", "BigDecimal", "Double"));
			temp.setHeatstate((String)Global.toNullString(map, "heatstate", "String", "String"));
			temp.setHeatbase((Double)Global.toNullString(map, "heatbase", "BigDecimal", "Double"));
			temp.setHeatrate((Double)Global.toNullString(map, "heatrate", "BigDecimal", "Double"));
			temp.setHousetype((String)Global.toNullString(map, "housetype", "String", "String"));
			temp.setBalance((Double)Global.toNullString(map, "balance", "BigDecimal", "Double"));
			temp.setMoney((Double)Global.toNullString(map, "money", "BigDecimal", "Double"));
			temp.setNeedmoney((Double)Global.toNullString(map, "needmoney", "BigDecimal", "Double"));
			temp.setLastdate((String)Global.toNullString(map, "lastdate", "Timestamp", "String"));
			temp.setPjtname((String)Global.toNullString(map, "pjtname", "String", "String"));
			temp.setCmtname((String)Global.toNullString(map, "cmtname", "String", "String"));
			temp.setBldname((String)Global.toNullString(map, "bldname", "String", "String"));
			temp.setUntname((String)Global.toNullString(map, "untname", "String", "String"));
			temp.setMchname((String)Global.toNullString(map, "mchname", "String", "String"));
			list.add(temp);

		}
		return list;
	}
	
	public Result assgionUsersComboSearch(
			Long pjtid,
			String queryStr,
			Integer cmtid,
			Integer bldid,
			String date,
			String type,
			Boolean all,
			HttpSession session)
	{
		ServletContext servletContext = session.getServletContext();    
	    ApplicationContext ctx = WebApplicationContextUtils.getWebApplicationContext(servletContext);
	    SessionFactory sessionFactory = (SessionFactory) ctx.getBean("sessionFactory");
	    Session hsession = SessionFactoryUtils.getSession(sessionFactory, true);
	    Transaction transaction = hsession.beginTransaction();
	    String hql;
	    Query query;
	    Result result = new Result();
	    try{
	    	query = hsession.createQuery("from HeatsysSetting");
			HeatsysSetting heatsysSetting = (HeatsysSetting)query.list().get(0);
			
			hql = "update UsersInfo ui set ui.projectInfo.pjtid=:pjtid where ui.usrid in (select u.usersInfo.usrid from UsersStatus u left outer join u.usersInfo.taskassignInfos ti where u.usid in (select max(u.usid) from UsersStatus u where statusdate<:statusdate group by u.usersInfo.usrid)";
			
			if (cmtid != null && cmtid != 0)
			{
				hql += " and u.communityInfo.cmtid=:cmtid";
			}
			
			if (bldid != null && bldid != 0)
			{
				hql += " and u.buildingInfo.bldid=:bldid";
			}
			
			if(!all)
			{
				hql += " and u.usersInfo.projectInfo.pjtid is null";
			}
			
			if(!(type.equals(Global.USERALL))){
				hql += " and u.status=:status";
			}
			
			hql += " and (u.usersInfo.usrname like '%"+queryStr+"%' or u.usersInfo.usertype like '%"+queryStr+"%' or u.usersInfo.phone like '%"+queryStr+"%'))";
			
			query = hsession.createQuery(hql);
			Calendar cal = Calendar.getInstance();
		    cal.setTime(Global.nosecondformat.parse(date));
		    cal.add(cal.DATE, 1);
			query.setTimestamp("statusdate", cal.getTime());
			
			query.setLong("pjtid", pjtid);
			
			if (cmtid != null && cmtid != 0)
			{
				query.setLong("cmtid", cmtid);
			}
			
			if (bldid != null && bldid != 0)
			{
				query.setLong("bldid", bldid);
			}
			
			if(!(type.equals(Global.USERALL))){
				query.setString("status", type);
			}
			
			int errorno = query.executeUpdate();
			
	    	transaction.commit();
	    }catch(Exception e){
	    	e.printStackTrace();
	    	transaction.rollback();
	    	result.setSuccess(false);
	    	result.setMessage(Global.FAILURESTR);
	    }
	    return result;
	}
	
	//assgion users to project
	public Result assgionUsers(Long pjtid,String queryOrids,Long type){
		Result reslt = null;
		String userids = null;
		if(type == 0)
			userids = getUserIdsByQuery(queryOrids);
		else
			userids = queryOrids;
		String[] ids = userids.split(",");
		for(String usrid : ids){
			String sql = "update users_info set pjtid = "+pjtid+" where isvalid = 1 and usrid="+usrid;
			int row = this.getJdbcTemplate().update(sql);
			if(row == 0 )
				reslt = new Result(false,"no this record usrid="+usrid);
				
		}
		if(reslt == null)
			return Global.SUCCESS;
		else
			return reslt;
	}
	//get usrids according to query condition
	public String getUserIdsByQuery(String query){
		String ids ="";
		String sql = "select usrid from users_info where isvalid = 1 and "+
				"(usrname like '%"+query+"' or usrtype like '"+query+"')";
		List rows = this.getJdbcTemplate().queryForList(sql);
		Iterator it = rows.iterator();
		while(it.hasNext()){
			Map map = (Map)it.next();
			ids =ids+(String)map.get("usrid");
		}
		return ids;
	}
	
	//assign project to staff
		//get staffid and staffname from staff_info
	public ListCount getStaffInfo(){
		ListCount listCount = new ListCount();
		
		String sql = "select count(*) from staff_info where isvalid = 1";
		Long totalProperty = (long)this.getJdbcTemplate().queryForInt(sql);
		listCount.setTotalProperty(totalProperty);
		sql = "select stfid,stfname from staff_info where isvalid =1";
		List rows = this.getJdbcTemplate().queryForList(sql); 
		Iterator it = rows.iterator();
		List list = new ArrayList();
		while(it.hasNext()){
			Map map = (Map)it.next();
			BaseInfo temp = new BaseInfo();
			temp.setId(((BigDecimal)map.get("stfid")).longValue());
			temp.setName((String)map.get("stfname"));
			list.add(temp);
		}
		listCount.setData(list);
		return listCount;
	}
		//assgion project to staff
	public Result assgionToStaff(String ids,Long pjtid,Long rightid,HttpSession session){
		ServletContext servletContext = session.getServletContext();    
	    ApplicationContext ctx = WebApplicationContextUtils.getWebApplicationContext(servletContext);
	    SessionFactory sessionFactory = (SessionFactory) ctx.getBean("sessionFactory");
	    Session hsession = SessionFactoryUtils.getSession(sessionFactory, true);
	    Transaction transaction = hsession.beginTransaction();
	    String hql;
	    Query query;
	    Result reslt = new Result();
	    try{
	    	String[] split = ids.split(",");
	    	List<String> staffids = new ArrayList<String>();
	    	for (int i = 0; i < split.length; i++)
    		{
	    		hql = "from StfGrpPjtMapping m where m.projectInfo.pjtid=:pjtid and m.staffInfo.stfid=:stfid";
	    		query = hsession.createQuery(hql);
	    		query.setLong("pjtid", pjtid);
	    		query.setLong("stfid", Long.parseLong(split[i]));
	    		List list = query.list();
	    		if (list.size() > 0)
	    		{
	    			StfGrpPjtMapping toAdd = (StfGrpPjtMapping)list.get(0);
	    			org.hibernate.heat.domain.ProjectInfo pi = new org.hibernate.heat.domain.ProjectInfo(pjtid);
	    			toAdd.setProjectInfo(pi);
	    			org.hibernate.heat.domain.StaffInfo si = new org.hibernate.heat.domain.StaffInfo(Long.parseLong(split[i]));
	    			toAdd.setStaffInfo(si);
	    			org.hibernate.heat.domain.OperationgroupInfo oi = new org.hibernate.heat.domain.OperationgroupInfo(rightid);
	    			toAdd.setOperationgroupInfo(oi);
	    			hsession.saveOrUpdate(toAdd);
	    		}
	    		else
	    		{
	    			StfGrpPjtMapping toAdd = new StfGrpPjtMapping();
	    			org.hibernate.heat.domain.ProjectInfo pi = new org.hibernate.heat.domain.ProjectInfo(pjtid);
	    			toAdd.setProjectInfo(pi);
	    			org.hibernate.heat.domain.StaffInfo si = new org.hibernate.heat.domain.StaffInfo(Long.parseLong(split[i]));
	    			toAdd.setStaffInfo(si);
	    			org.hibernate.heat.domain.OperationgroupInfo oi = new org.hibernate.heat.domain.OperationgroupInfo(rightid);
	    			toAdd.setOperationgroupInfo(oi);
	    			hsession.saveOrUpdate(toAdd);
	    		}
    		}
	    	transaction.commit();
	    }catch(Exception e){
	    	e.printStackTrace();
	    	transaction.rollback();
	    	reslt.setSuccess(false);
	    	reslt.setMessage(Global.FAILURESTR);
	    	reslt.setTotalProperty((long)0);
	    	reslt.setData(new ArrayList());
	    }
	    return reslt;
	}
}
