library(effsize)

dothemath = function(a,b,c,d) {
  m <- matrix(c(a,b,c,d),
              nrow = 2,
              dimnames =
                list(c("Problem", "No problem"),
                     c("Specific", "Traditional")))
  
  return(fisher.test(m))
}

# --------------------------------------------------------
# TRADITIONAL VS SPECIFIC
# --------------------------------------------------------

# change proneness
traditional_with_d <- 2641
traditional_with_non_d <- 1094
specific_with_d <- 1158
specific_with_non_d <- 626

dothemath(specific_with_d,specific_with_non_d,traditional_with_d,traditional_with_non_d)

# defect proneness
traditional_with_d <- 306
traditional_with_non_d <- 652

specific_with_d <- 112
specific_with_non_d <- 662

dothemath(specific_with_d,specific_with_non_d,traditional_with_d,traditional_with_non_d)



# --------------------------------------------------------
# SPECIFIC VS CLEAN
# --------------------------------------------------------

# change proneness
specific_with_d <- 1158
specific_with_non_d <- 626
clean_with_d <- 5686
clean_with_non_d <- 9125


dothemath(specific_with_d,specific_with_non_d,clean_with_d,clean_with_non_d)

# defect proneness
specific_with_d <- 112
specific_with_non_d <- 662
clean_with_d <- 485
clean_with_non_d <- 5885


dothemath(specific_with_d,specific_with_non_d,clean_with_d,clean_with_non_d)



# --------------------------------------------------------
# TRADITIONAL VS CLEAN
# --------------------------------------------------------

# change proneness
traditional_with_d <- 2641
traditional_with_non_d <- 1094
clean_with_d <- 5686
clean_with_non_d <- 9125


dothemath(traditional_with_d,traditional_with_non_d,clean_with_d,clean_with_non_d)

# defect proneness
traditional_with_d <- 306
traditional_with_non_d <- 652
clean_with_d <- 485
clean_with_non_d <- 5885


dothemath(traditional_with_d,traditional_with_non_d,clean_with_d,clean_with_non_d)







# --------------------------------------------------------
# TRADITIONAL VS SPECIFIC
# PER LOC
# --------------------------------------------------------

# change proneness
specific_with_d_1 <- 19
specific_with_non_d_1 <- 30

specific_with_d_2 <- 62
specific_with_non_d_2 <- 73

specific_with_d_3 <- 196
specific_with_non_d_3 <- 155

specific_with_d_4 <- 881
specific_with_non_d_4 <- 368

traditional_with_d_1 <- 1
traditional_with_non_d_1 <- 2

traditional_with_d_2 <- 14
traditional_with_non_d_2 <- 29

traditional_with_d_3 <- 283
traditional_with_non_d_3 <- 268

traditional_with_d_4 <- 2343
traditional_with_non_d_4 <- 795

dothemath(specific_with_d_1,specific_with_non_d_1,traditional_with_d_1,traditional_with_non_d_1)
dothemath(specific_with_d_2,specific_with_non_d_2,traditional_with_d_2,traditional_with_non_d_2)
dothemath(specific_with_d_3,specific_with_non_d_3,traditional_with_d_3,traditional_with_non_d_3)
dothemath(specific_with_d_4,specific_with_non_d_4,traditional_with_d_4,traditional_with_non_d_4)

# defect proneness

specific_with_d_1 <- 0
specific_with_non_d_1 <- 16

specific_with_d_2 <- 4
specific_with_non_d_2 <- 52

specific_with_d_3 <- 11
specific_with_non_d_3 <- 147

specific_with_d_4 <- 97
specific_with_non_d_4 <- 447

traditional_with_d_1 <- 0
traditional_with_non_d_1 <- 0

traditional_with_d_2 <- 1
traditional_with_non_d_2 <- 1

traditional_with_d_3 <- 9
traditional_with_non_d_3 <- 67

traditional_with_d_4 <- 296
traditional_with_non_d_4 <- 584

dothemath(specific_with_d_1,specific_with_non_d_1,traditional_with_d_1,traditional_with_non_d_1)
dothemath(specific_with_d_2,specific_with_non_d_2,traditional_with_d_2,traditional_with_non_d_2)
dothemath(specific_with_d_3,specific_with_non_d_3,traditional_with_d_3,traditional_with_non_d_3)
dothemath(specific_with_d_4,specific_with_non_d_4,traditional_with_d_4,traditional_with_non_d_4)






# --------------------------------------------------------
# SPECIFIC VS CLEAN
# PER LOC
# --------------------------------------------------------

# change proneness
specific_with_d_1 <- 19
specific_with_non_d_1 <- 30

specific_with_d_2 <- 62
specific_with_non_d_2 <- 73

specific_with_d_3 <- 196
specific_with_non_d_3 <- 155

specific_with_d_4 <- 881
specific_with_non_d_4 <- 368

clean_with_d_1 <- 1183
clean_with_non_d_1 <- 3274

clean_with_d_2 <- 1496
clean_with_non_d_2 <- 3005

clean_with_d_3 <- 1845
clean_with_non_d_3 <- 2067

clean_with_d_4 <- 1162
clean_with_non_d_4 <- 779

dothemath(specific_with_d_1,specific_with_non_d_1,clean_with_d_1,clean_with_non_d_1)
dothemath(specific_with_d_2,specific_with_non_d_2,clean_with_d_2,clean_with_non_d_2)
dothemath(specific_with_d_3,specific_with_non_d_3,clean_with_d_3,clean_with_non_d_3)
dothemath(specific_with_d_4,specific_with_non_d_4,clean_with_d_4,clean_with_non_d_4)

# defect proneness

specific_with_d_1 <- 0
specific_with_non_d_1 <- 16

specific_with_d_2 <- 4
specific_with_non_d_2 <- 52

specific_with_d_3 <- 11
specific_with_non_d_3 <- 147

specific_with_d_4 <- 97
specific_with_non_d_4 <- 447

clean_with_d_1 <- 59
clean_with_non_d_1 <- 1688

clean_with_d_2 <- 94
clean_with_non_d_2 <- 1779

clean_with_d_3 <- 166
clean_with_non_d_3 <- 1606

clean_with_d_4 <- 166 # coincidence, not a mistake
clean_with_non_d_4 <- 812

dothemath(specific_with_d_1,specific_with_non_d_1,clean_with_d_1,clean_with_non_d_1)
dothemath(specific_with_d_2,specific_with_non_d_2,clean_with_d_2,clean_with_non_d_2)
dothemath(specific_with_d_3,specific_with_non_d_3,clean_with_d_3,clean_with_non_d_3)
dothemath(specific_with_d_4,specific_with_non_d_4,clean_with_d_4,clean_with_non_d_4)






# --------------------------------------------------------
# TRADITIONAL VS CLEAN
# PER LOC
# --------------------------------------------------------
traditional_with_d_1 <- 1
traditional_with_non_d_1 <- 2

traditional_with_d_2 <- 14
traditional_with_non_d_2 <- 29

traditional_with_d_3 <- 283
traditional_with_non_d_3 <- 268

traditional_with_d_4 <- 2343
traditional_with_non_d_4 <- 795

clean_with_d_1 <- 1254
clean_with_non_d_1 <- 3419

clean_with_d_2 <- 1640
clean_with_non_d_2 <- 3133

clean_with_d_3 <- 1963
clean_with_non_d_3 <- 2079

clean_with_d_4 <- 829
clean_with_non_d_4 <- 494

dothemath(traditional_with_d_1,traditional_with_non_d_1,clean_with_d_1,clean_with_non_d_1)
dothemath(traditional_with_d_2,traditional_with_non_d_2,clean_with_d_2,clean_with_non_d_2)
dothemath(traditional_with_d_3,traditional_with_non_d_3,clean_with_d_3,clean_with_non_d_3)
dothemath(traditional_with_d_4,traditional_with_non_d_4,clean_with_d_4,clean_with_non_d_4)


# defect proneness

traditional_with_d_1 <- 0
traditional_with_non_d_1 <- 0

traditional_with_d_2 <- 1
traditional_with_non_d_2 <- 1

traditional_with_d_3 <- 9
traditional_with_non_d_3 <- 67

traditional_with_d_4 <- 296
traditional_with_non_d_4 <- 584


clean_with_d_1 <- 63
clean_with_non_d_1 <- 1827

clean_with_d_2 <- 99
clean_with_non_d_2 <- 1837

clean_with_d_3 <- 180
clean_with_non_d_3 <- 1567

clean_with_d_4 <- 143
clean_with_non_d_4 <- 654

dothemath(traditional_with_d_1,traditional_with_non_d_1,clean_with_d_1,clean_with_non_d_1)
dothemath(traditional_with_d_2,traditional_with_non_d_2,clean_with_d_2,clean_with_non_d_2)
dothemath(traditional_with_d_3,traditional_with_non_d_3,clean_with_d_3,clean_with_non_d_3)
dothemath(traditional_with_d_4,traditional_with_non_d_4,clean_with_d_4,clean_with_non_d_4)

