library(sqldf)


# loading data
smells <- read.csv(file="../data/pmd-smells-head.csv", header=T)
#ck <- read.csv(file="../data/ck.csv", header=T)
attributes <- read.csv(file="../data/attributes.csv", header=T)
attributes <- attributes[
  attributes$project != 'code2cloud.server'& 
    attributes$project != 'poulpe'& 
    attributes$project != 'ewcms'& 
    attributes$project != 'school'& 
    attributes$project != 'sshapp'& 
    attributes$project != 'DemoSite'& 
    attributes$project != 'infoscoop'& 
    attributes$project != 'resthub-spring-stack'& 
    attributes$project != 'iteach'& 
    attributes$project != 'falcon'& 
    attributes$project != 'shiro'& 
    attributes$project != 'extdirectspring'& 
    attributes$project != 'motech-server-pillreminder-0.18'& 
    attributes$project != 'ualerts-server'& 
    attributes$project != 'OpenConext-selfservice'& 
    attributes$project != 'portal'& 
    attributes$project != 'akvo-flow'& 
    attributes$project != 'Condominio'& 
    attributes$project != 'cms4j'& 
    attributes$project != 'yoga',
  ]

roles <- c("controller", "repository", "service", "entity", "component")
problems <- c("CyclomaticComplexity", "CouplingBetweenObjects", "GodClass", "ExcessiveMethodLength", "ExcessiveClassLength", "ExcessiveParameterList")
for(role in roles) {
  filtered <- attributes[attributes$role == role,]
  
  for(problem in problems) {

      qty <- 0
      
      for(file in filtered$file) {
        if(nrow(smells[smells$Rule == problem & smells$File == file,])>0) {
          qty <- qty + 1
        }
      }
      
      print(paste(role,nrow(filtered),problem,qty, sep=","))
      
  }
  
}
