library(sqldf)

# specific smells
smells <- read.csv(file="../data/old-smells.csv", header=T)
attributes <- read.csv(file="../data/attributes.csv", header=T)
pmd <- read.csv(file="../data/pmd-smells.csv", header=T)

get_smell_sample <- function(smell) {
  set.seed(123)
  smelly_ones <- sample(smells[smells$smell == smell,]$file, 5)
  
  print(smelly_ones)
} 


get_smell_sample('Smart Repository')
get_smell_sample('Fat Repository')
get_smell_sample('Multiple queries')

get_smell_sample('Promiscuous Controller')
get_smell_sample('Smart Controller')

get_smell_sample('DB Querying service')


# traditional smells
# repeat for each rule
unique(pmd$Rule)
set.seed(123)
rule <- "CouplingBetweenObjects"
s <- sqldf(paste("select p.* from pmd p join attributes a on a.file = p.file where Rule = '", rule, "' and role = 'controller'", sep=""))$File
sample(s, 2)
s <- sqldf(paste("select p.* from pmd p join attributes a on a.file = p.file where Rule = '", rule, "' and role = 'service'", sep=""))$File
sample(s, 2)
s <- sqldf(paste("select p.* from pmd p join attributes a on a.file = p.file where Rule = '", rule, "' and role = 'repository'", sep=""))$File
sample(s, 2)



# non smelly ones
# change SQL for each role

set.seed(123)
c <- sqldf("select a.file from attributes a left join smells s on s.file = a.file left join pmd p on a.file = p.file where smell is null and Rule is null and  a.role = 'repository'")
sample(c$file,10)

