library(sqldf)


# loading data
smells <- read.csv(file="../data/smells.csv", header=T)
#ck <- read.csv(file="../data/ck.csv", header=T)
attributes <- read.csv(file="../data/attributes.csv", header=T)
attributes <- attributes[
    attributes$project != 'code2cloud.server'& 
    attributes$project != 'poulpe'& 
    attributes$project != 'ewcms'& 
    attributes$project != 'school'& 
    attributes$project != 'sshapp'& 
    attributes$project != 'DemoSite'& 
    attributes$project != 'infoscoop'& 
    attributes$project != 'resthub-spring-stack'& 
    attributes$project != 'iteach'& 
    attributes$project != 'falcon'& 
    attributes$project != 'shiro'& 
    attributes$project != 'extdirectspring'& 
    attributes$project != 'motech-server-pillreminder-0.18'& 
    attributes$project != 'ualerts-server'& 
    attributes$project != 'OpenConext-selfservice'& 
    attributes$project != 'portal'& 
    attributes$project != 'akvo-flow'& 
    attributes$project != 'Condominio'& 
    attributes$project != 'cms4j'& 
    attributes$project != 'yoga',
]

roles <- c("controller", "repository", "service", "entity", "component")


# functions
fancy_analysis <- function(role, smell, a1, a2='', isbool=F) {
  classes_from_that_role <- attributes[attributes$role == role,]
  
  #sql <- "select count(*) from classes_from_that_role"
  #if(!isbool && a1!="") sql <- paste(sql, "where ", a1, ">=1")
  #if(!isbool && a2!="") sql <- paste(sql, "and", a2, ">=1")
  #total_roles <- sqldf(sql)
  total_roles <- nrow(classes_from_that_role)
  
  total_smelly <- table(smells$smell)[smell]
  
  pct <- total_smelly / total_roles
  print(paste("**", smell))
  print(paste("total", role, total_roles, "total", smell, total_smelly, "pct", pct))
  
}

fancy_analysis('repository', 'Smart Repository', 'sqlcomplexity', 'mccabe' )
fancy_analysis('repository', 'Fat Repository', 'entities')
fancy_analysis('repository', 'Multiple queries', 'persistinvocations', '', T)

fancy_analysis('controller', 'Promiscuous Controller', 'routes', 'services')
fancy_analysis('controller', 'Smart Controller', 'springrfc')

fancy_analysis('service', 'DB Querying service', 'persistence', '', T)



