library(vioplot)
library(effsize)

# all smells
severity_traditional <- c(4,4,3,5,4,2,4,5,5,3,3,3,3,4,3,0,0,0,3,0,5,4,4,5,0,0,0,0,3,2,4,0,4,5,4,0,5,0,0,0)
severity_smelly      <- c(4,5,4,3,4,4,4,5,5,4,5,4,1,5,3,0,0,0,0,0,4,5,3,3,3,5,5,3,5,0,2,0,3,3,4,5,2,4,2,4)
severity_non_smelly <-  c(3,2,2,4,5,3,1,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,4,3,2,0,0,0,0,0,2,0,0,1,4,3,0,0,0,0,4)


boxplot(severity_traditional, severity_non_smelly, severity_smelly, xlab="")
labels <- c("Traditional", "Clean", "MVC")
axis(1, at=1:length(labels), labels=labels)

vioplot(severity_non_smelly, severity_smelly, severity_traditional, names=c("Clean", "MVC", "Traditional"), col="gold")

wilcox.test(severity_traditional, severity_non_smelly)
cliff.delta(severity_traditional, severity_non_smelly)

wilcox.test(severity_traditional, severity_smelly)
cliff.delta(severity_traditional, severity_smelly)

wilcox.test(severity_smelly, severity_non_smelly)
cliff.delta(severity_smelly, severity_non_smelly)



# per smell
dbquerying_service <- c(4,0,4,3,4,4)
fat_repository <- c(5,5,4,0,4)
smart_controller <- c(4,4,4,5,5,5,3,2,5,2)
promiscuous_controller <- c(3,5,3,3,5,3)
smart_repository <- c(4,4,1,3,2)
multiple_queries <- c(0,0,0,5,5,0,0,3)


boxplot(dbquerying_service, fat_repository, smart_controller, promiscuous_controller, smart_repository, multiple_queries)

vioplot(dbquerying_service, fat_repository, smart_controller, promiscuous_controller, smart_repository, multiple_queries,
        names=c("MS", "FR", "SC", "PC", "SR", "LRM"), col="gold")


# per traditional smell
complex_class <- c(4,0,0,0,0,0)
long_method <- c(4,0,0,4,5,0,0,2,4)
long_class <- c(3,3,4,3,4,3,5)
cbo <- c(5,4,5,0,0)
long_parameter_list <- c(2,0,3,4,0)
god_class <- c(5,5,3,3,4,3,4)

vioplot(complex_class, long_method, long_class, cbo, long_parameter_list, god_class,
        names=c("CC", "LM", "LC", "CBO", "LPL", "GC"), col="gold")


# removing only multiple queries
severity_traditional <- c(4,4,3,5,4,2,4,5,5,3,3,3,3,4,3,0,0,0,3,0,5,4,4,5,0,0,0,0,3,2,4,0,4,5,4,0,5,0,0,0)
severity_smelly      <- c(4,5,4,3,4,4,4,5,5,4,4,1,4,5,3,3,3,5,5,3,5,0,2,0,3,3,4,5,2,4,2,4)

wilcox.test(severity_traditional, severity_smelly)
cliff.delta(severity_traditional, severity_smelly)

# --------------------------------------------
# participants experience
exp <- c(
  '>8 yrs',
  '1 year',
  '2-4 yrs',
  '>8 yrs',
  '6-8 yrs',
  '>8 yrs',
  '4-6 yrs',
  '>8 yrs',
  '>8 yrs',
  '>8 yrs',
  '4-6 yrs',
  '>8 yrs',
  '>8 yrs',
  '4-6 yrs',
  '6-8 yrs',
  '>8 yrs',
  '>8 yrs',
  '>8 yrs',
  '>8 yrs',
  '>8 yrs',
  '4-6 yrs'
)


a <- table(exp)
barplot(a, cex.names = 1, col="darkolivegreen3", ylim=c(0,15))


exp_web <- 
  c(
    '1-2 yrs',
    '1-2 yrs',
    '2-4 yrs',
    '2-4 yrs',
    '1-2 yrs',
    '>8 yrs',
    '2-4 yrs',
    '6-8 yrs',
    '1-2 yrs',
    '1-2 yrs',
    '1-2 yrs',
    '>8 yrs',
    '>8 yrs',
    '2-4 yrs',
    '1-2 yrs',
    '2-4 yrs',
    '4-6 yrs',
    '1-2 yrs',
    '2-4 yrs',
    '1-2 yrs',
    '1-2 yrs'
  )

a <- table(exp_web)
barplot(a, cex.names = 1, col="darkolivegreen3", ylim=c(0,15))
