library(sqldf)

attributes <- read.csv(file="../data/attributes.csv", header=T)

# --- 
# sampling 20 projects
attributes <- attributes[
  attributes$project != 'atlas' & 
  attributes$project != 'bandwidth-on-demand' & 
  attributes$project != 'cmt' & 
  attributes$project != 'encuestame' & 
  attributes$project != 'justjournal' & 
  attributes$project != 'mifos-head' & 
  attributes$project != 'mystamps' & 
  attributes$project != 'open-lmis' & 
  attributes$project != 'orangeleap-tangerine' & 
  attributes$project != 'oztrack' & 
  attributes$project != 'qcadoo' & 
  attributes$project != 'school-admin' & 
  attributes$project != 'ssp' &
  attributes$project != 'tatami-team' &
  attributes$project != 'uaa' 
  ,]

projects <- unique(attributes$project)
set.seed(123)
twenty <- sample(projects, 20)

attributes <- attributes[(attributes$project %in% twenty),]
# -----


# Per architectural role
controllers <- attributes[attributes$role == 'controller',]
repositories <- attributes[attributes$role == 'repository',]
services <- attributes[attributes$role == 'service',]

######################################################
## greater than one

# Summary of all controller metrics
summary(controllers[controllers$routes>=1,]$routes)
summary(controllers[controllers$services>=1,]$services)
summary(controllers[controllers$springrfc>=1,]$springrfc)

# Summary of all repository metrics
summary(repositories[repositories$sqlcomplexity>=1,]$sqlcomplexity)
summary(repositories[repositories$mccabe>=1,]$mccabe)
summary(repositories[repositories$entities>=1,]$entities)
table(repositories$persistinvocations)

# Summary of all service metrics
table(services$persistence)